###############################################################################################################################
###############################################################################################################################
###############################################################################################################################

        # Python script for Figures in following paper (c) by W. Yao, L. Puts, K. Williams and D. Lenstra
        # as part of the work published in "An All-Optical Spiking Laser Neuron Integrated in Generic 
        # InP Photonic Circuit Technology" published in Optics Express
        # 
        # This work is licensed under a Creative Commons Attribution-NonCommercial-ShareAlike 4.0 International License.
        # 
        # You should have received a copy of the license along with this work. If not, see 
        # <https://creativecommons.org/licenses/by-nc-sa/4.0/>.
        
        # Eindhoven Univesity of Technology, Eindhoven, the Netherlands, May 2025
        
        # Contact: l.puts@tue.nl

###############################################################################################################################
###############################################################################################################################
###############################################################################################################################

import numpy as np
import matplotlib.pyplot as plt
# folder: C:\Users\20175882\OneDrive - TU Eindhoven\lab_August2024\2024.08.08 - 21E33 OSA sweeps

plt.rcParams['font.size'] = 13
plt.rcParams['font.family' ] ='Times New Roman'
plt.rcParams['mathtext.default'] = 'regular'

file='Sample 21e33 laser l3 OSA -1.100V 2024-08-08_14_11_46_fine.npy'
data=np.load(file)

current=np.linspace(40, 60,data.shape[0])

fig=plt.figure(0,figsize=(4.5,3))
c=plt.pcolor(np.linspace(1542,1552,data.shape[1]),current,data,cmap='Reds_r',vmin=-55)
plt.xlabel('Wavelength [nm]')
plt.ylabel(r'$I_{SOA} [mA]$')
cbar=fig.colorbar(c,label='Optical power [dBm]')
plt.tight_layout()